
#include <stm32f10x.h>              /* STM32F10x Library */


#include "w6100.h"						/* W5100 Register definition */
#include "w6100_init.h"
#include "SPI.h"
#include "socket.h"
//#include "webpage.h"
#include "httpult.h"
#include "dhcp.h"
#ifndef DATA_BUF_SIZE
	#define DATA_BUF_SIZE			2048
#endif
#define AS_IPV4 2
#define AS_IPV6 23
#define AS_IPDUAL 11

static uint16_t any_port = 	50000;
//static uint8_t curr_state[8] = {0,};
static uint8_t sock_state[8] = {0,};
char* msg_v4 = "IPv4 mode";
char* msg_v6 = "IPv6 mode";
char* msg_dual = "Dual IP mode";

uint8_t buff[2048];

uint8 reboot_flag = 0;
CONFIG_MSG ConfigMsg;
void dhcp_network(void);
/******************************************************************************/
/*******************           Main function             **********************/
/******************************************************************************/
int main(void)
{
	
	uint8_t dhcpret=0;
	uint8_t server_ip[4]={192,168,1,11};			
	uint8_t server_ip6[16]={0xfe, 0x80, 0x00, 0x00,
							          0x00, 0x00, 0x00, 0x00,
							          0x75, 0x03, 0x1b, 0x81,
							          0xf3, 0xee, 0x0c, 0x4a};		
	uint16_t server_port=5000;								
  uint16_t local_port=6000;									
  uint16_t len=0;

  /*mcu system init*/							  
	Systick_Init(72);	
	TimerInit();
	
	/*usart init*/
	USART1_Init(); 		
	printf("usart init ok\r\n");

	/*gpio SPI FSMC init*/
	GPIO_Configuration();	
												
#if _WIZCHIP_IO_MODE_ & _WIZCHIP_IO_MODE_BUS_INDIR_
	 FSMC_Init();
#else	
	WIZ_SPI_Init();
#endif
	
	/*reset w6100*/
	Reset_W6100();

  /*init dhcp client*/
	init_dhcp_client();
	while(1)
	{
	  /*check dhcp state*/
		dhcpret = check_DHCP_state(SOCK_DHCP);
		switch(dhcpret)
		{
			case DHCP_RET_NONE:
			break;
			case DHCP_RET_TIMEOUT:
				   printf("time out\r\n");
			break;
			case DHCP_RET_UPDATE:
					 dhcp_network();
			break;
			case DHCP_RET_CONFLICT:
			while(1);
			default:
			break;
		}
	}
	
	
}
void dhcp_network(void)
{
  uint8 ip[4];
  setSHAR(DHCP_GET.mac);/*Macַ*/
  setSUBR(DHCP_GET.sub);/**/
  setGAR(DHCP_GET.gw);/*Ĭ*/
  setSIPR(DHCP_GET.lip);/*Ipַ*/

  //Init. TX & RX Memory size of w5100s
 // sysinit(0x55, 0x55); /*ʼ4socket*/ 
  setRTR(2000);/*ʱֵ*/
  setRCR(3);/*·ʹ*/
 
  getSIPR (ip);
  printf("IP : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getSUBR(ip);
	printf("SN : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getGAR(ip);
  printf("GW : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);

}



